/*****************************************************
Arxeio ylopoihshs	: Hanoi.c
Syggrafeas			: Lougiakis Christos
Skopos				: Skeleton program gia Ylopoihsh Algorithmoy Hanoi me Stoives
******************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "ch4_Stack.h"
#include "TStoixeioyStoivas.h"

/*dhlwseis synarthsewn*/

void Input(FILE * from, TStoivas *S, int *n);
void Output(FILE * to, TStoivas *S);
void Move(TStoivas *from, TStoivas *to);
void recursiveHanoi(int level, TStoivas *from, TStoivas *to, TStoivas *with);

/*Main synartisi*/

int main(void){
    TStoivas Stoiva_A, Stoiva_B, Stoiva_C;
    int n;
	FILE *finp, *foutp;

	Stoiva_A=Stoiva_dimiourgia();
	Stoiva_B=Stoiva_dimiourgia();
	Stoiva_C=Stoiva_dimiourgia();
	
	finp=fopen("Aktina.txt","r");           /*1)arxeio me dedomena typou stoixeion int*/
	/*finp=fopen("AktinaYpsos.txt","r");*/  /*2)arxeio me dedomena typou stoixeion struct*/
	Input(finp, &Stoiva_A, &n);
	fclose(finp);

	recursiveHanoi(n, &Stoiva_A, &Stoiva_C, &Stoiva_B);

	foutp=fopen("to.txt","w");
	Output(foutp, &Stoiva_C);
	fclose(foutp);

	free(Stoiva_A);
	free(Stoiva_B);
	free(Stoiva_C);
	return 0;
}

/*orismos synarthsewn*/

void Input(FILE *from, TStoivas *S, int *n) {
/* Diavazei stoixeia apo to from kai ta wthei sthn S.
   Epistrefei ton arithmo twn stoixeiwn poy wthhse
*/
	int y=0;
	TStoixeioyStoivas stoixeio,temp;
	(*n)=1;
	TSstoiva_readValue(from,&temp);
	Stoiva_othisi(*S,temp,&y);
	while(TSstoiva_readValue(from,&temp)!=EOF){
		Stoiva_PopValue(*S,&stoixeio,&y);
		if ( mikrotero(temp,stoixeio)){
		    	Stoiva_othisi(*S,temp,&y);
		    	(*n)++;
		}
	}
}

void Move(TStoivas *Source, TStoivas *Target) {
/* Metaferei ena stoixeio apo thn stoiva Source sthn Target */
	int y=0;
	TStoixeioyStoivas stoixeio;
	Stoiva_PopValue(*Source,&stoixeio,&y);
	Stoiva_PopState(Source,&y);
	Stoiva_othisi(*Target,stoixeio,&y);
}

void recursiveHanoi(int level, TStoivas *from, TStoivas *to, TStoivas *with) {
/* Level einai o arithmos twn diskwn kai
   from o arxikh stoiva , to h telikh kai with h bohuhtikh
*/
     if (level >= 1) {
        recursiveHanoi(level - 1, from, with, to);
        Move(from, to);
        recursiveHanoi(level - 1, with, to, from);
     }
}

void Output(FILE *to, TStoivas *S){
/* Exagei stoixeia apo thn S kai ta ektypvnei sto to */
    TStoixeioyStoivas stoixeio;
    int y=0;
    while ( y!=1 ){
		Stoiva_PopValue(*S,&stoixeio,&y);
		if(y==1)
			break;
		TSstoiva_writeValue(to,stoixeio);
		Stoiva_PopState(S,&y);
	}
}
